BooleanPerceptronClassifier (Lucene 10.5.1 classification API)
Description: declaration: package: org.apache.lucene.classification, class: BooleanPerceptronClassifier

Package org.apache.lucene.classification

# Class BooleanPerceptronClassifier

java.lang.Object
org.apache.lucene.classification.BooleanPerceptronClassifier

All Implemented Interfaces:
  `Classifier<Boolean>`

public class BooleanPerceptronClassifier extends Object implements Classifier<Boolean>
A perceptron (see `http://en.wikipedia.org/wiki/Perceptron`) based `Boolean` `Classifier`. The weights are calculated using `TermsEnum.totalTermFreq()` both on a per field and a per document basis and then a corresponding `FST` is used for class assignment.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BooleanPerceptronClassifier(IndexReader indexReader, Analyzer analyzer, Query query, Integer batchSize, Double bias, String classFieldName, String textFieldName)`
  Creates a `BooleanPerceptronClassifier`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ClassificationResult<Boolean>`
  `assignClass(String text)`
  Assign a class (with score) to the given text String
  `List<ClassificationResult<Boolean>>`
  `getClasses(String text)`
  Get all the classes (sorted by score, descending) assigned to the given text String.
  `List<ClassificationResult<Boolean>>`
  `getClasses(String text, int max)`
  Get the first `max` classes (sorted by score, descending) assigned to the given text String.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BooleanPerceptronClassifier

    public BooleanPerceptronClassifier(IndexReader indexReader, Analyzer analyzer, Query query, Integer batchSize, Double bias, String classFieldName, String textFieldName) throws IOException
    Creates a `BooleanPerceptronClassifier`
    Parameters:
      `indexReader` - the reader on the index to be used for classification
      `analyzer` - an `Analyzer` used to analyze unseen text
      `query` - a `Query` to eventually filter the docs used for training the classifier, or `null` if all the indexed docs should be used
      `batchSize` - the size of the batch of docs to use for updating the perceptron weights
      `bias` - the bias used for class separation
      `classFieldName` - the name of the field used as the output for the classifier
      `textFieldName` - the name of the field used as input for the classifier
    Throws:
      `IOException` - if the building of the underlying `FST` fails and / or `TermsEnum` for the text field cannot be found

- ## Method Details

  - ### assignClass

    public ClassificationResult<Boolean> assignClass(String text) throws IOException
    Description copied from interface: `Classifier`
    Assign a class (with score) to the given text String
    Specified by:
      `assignClass` in interface `Classifier<Boolean>`
    Parameters:
      `text` - a String containing text to be classified
    Returns:
      a `ClassificationResult` holding assigned class of type `T` and score
    Throws:
      `IOException` - If there is a low-level I/O error.

  - ### getClasses

    public List<ClassificationResult<Boolean>> getClasses(String text)
    Description copied from interface: `Classifier`
    Get all the classes (sorted by score, descending) assigned to the given text String.
    Specified by:
      `getClasses` in interface `Classifier<Boolean>`
    Parameters:
      `text` - a String containing text to be classified
    Returns:
      the whole list of `ClassificationResult`, the classes and scores. Returns `null` if the classifier can't make lists.

  - ### getClasses

    public List<ClassificationResult<Boolean>> getClasses(String text, int max)
    Description copied from interface: `Classifier`
    Get the first `max` classes (sorted by score, descending) assigned to the given text String.
    Specified by:
      `getClasses` in interface `Classifier<Boolean>`
    Parameters:
      `text` - a String containing text to be classified
      `max` - the number of return list elements
    Returns:
      the whole list of `ClassificationResult`, the classes and scores. Cut for "max" number of elements. Returns `null` if the classifier can't make lists.